import PyTango
import time
import struct
from keithley20xx import core


def test_keithley_orig(k, rang):
    average = 0
    k.preset()
    start = time.time()
    for i in range(rang):
        k.initiate()
        print(k.read_fresh) # struct.unpack('f',keithley.read_fresh)[0]
    end = time.time()
    return (end - start), average


def test_keithley_gpib(k, rang):
    k.preset()
    k.voltage_rang = '2.0'
    k.acquisition_method = 'astr'
    time.sleep(1)
    average = 0
    print(k.read_fresh)
    start = time.time()
    for i in range(rang):
        average += eval(k.read_fresh)
    end = time.time()
    print(k.read_fresh)
    return (end - start), average


def test_keithley(k, rang):
    k.output_data_elements = ['read']
    average = 0
    k.initiate()
    print(k.read_fresh)
    start = time.time()
    for i in range(rang):
        # keithley.initiate()
        average += eval(k.read_fresh) # struct.unpack('f',keithley.read_fresh)[0]
    end = time.time()
    k.initiate()
    print(k.read_fresh)
    return (end - start), average


def data_fresh(k, measures, timer_value, nplc_value): #rang, read_time, nplc):
    print(k.identification)
    # keithley.initiate_continuous = 1

    k.timer_measure_layer = timer_value
    k.source_measure_control = 'TIM'
    k.output_data_elements = ['read']
    k.count_measure_control = measures + 2
    k.voltage_nplc = nplc_value
    overtime = 0
    average = 0



    k.abort()
    k.initiate()
    print(k.read_fresh)
    start = time.time()
    print(k.read_fresh)
    end = time.time()
    print(end - start)

    meas_start = time.time()

    overhead = []
    for i in range(measures):
        # keithley.initiate()
        start = time.time()
        average += eval(k.read_fresh) # struct.unpack('f',keithley.read_fresh)[0]
        end = time.time()
        overhead += [(end - start) - timer_value]
        if (end - start) - nplc_value/50. > timer_value:
            #
            overtime_meas = (end - start) - nplc_value/50. - timer_value
            print('\t - ' * 5 + str(overtime_meas))
            overtime += 1
    meas_end = time.time()
    meas_overall_time = meas_end - meas_start
    print(meas_end - meas_start)
    print('Mean measure time: \t %.8f' % (meas_overall_time*1.0/measures))
    print(overtime)
    print(nplc_value, max(overhead), max(overhead)*100 )




k = core.Keithley()
kk = core.Keithley('gpib/idlab/keithley2010')


# elapsed_time, out_value = test_keithley_orig(keithley, measures)
# print('Elapsed test keithley time: %s\n' % elapsed_time)
# print('Average output value: %1.6f\n' % (out_value/measures))
#
# elapsed_time, out_value = test_keithley(keithley, measures)
# print('Elapsed test 2001 time: %s\n' % elapsed_time)
# print('Average output value: %1.6f\n' % (out_value/measures))
#
# elapsed_time, out_value = test_keithley_gpib(keithley, measures)
# print('Elapsed test keithley time: %s\n' % elapsed_time)
# print('Average output value: %1.6f\n' % (out_value/measures))


# elapsed_time1, out_value = test_keithley_orig(keithley2010, measures)
# print('Elapsed test keithley2010 time: %s\n' % elapsed_time1)
# print('Average output value: %1.6f\n' % (out_value/measures))
#
# elapsed_time2, out_value = test_keithley(keithley2010, measures)
# print('Elapsed test 2010 time: %s\n' % elapsed_time2)
# print('Average output value: %1.6f\n' % (out_value/measures))


measures =      10
timer_value =   0.04 # 0.01 = 10ms
nplc_value =    0.5    # 1 = 20ms
print('Keithley 2001')
data_fresh(k, measures, timer_value, nplc_value)
print('\nKeithley 2010')
data_fresh(kk, measures, timer_value, nplc_value)

# elapsed_time, out_value = test_keithley_gpib(keithley2010, measures)
# print('Elapsed test keithley2010 time: %s\n' % elapsed_time)
# print('Average output value: %1.6f\n' % (out_value/measures))


# measures = 3900
#
# elapsed_time, out_value = test_keithley_gpib(keithley, measures)
# print('Elapsed test keithley time: %s\n' % elapsed_time)
# print('Average output value: %1.6f\n' % (out_value/measures))
#
# elapsed_time, out_value = test_keithley_gpib(keithley2010, measures)
# print('Elapsed test keithley2010 time: %s\n' % elapsed_time)
# print('Average output value: %1.6f\n' % (out_value/measures))
